//------------------------------------------------------------------------------
//
//  npcsv.h
//
//  ANTz application based on NPE
//
//  Created by Shane Saxon on 3/13/11.
//  Copyright Saxon Digital 2010-2011. All rights reserved.
//
//------------------------------------------------------------------------------
#ifndef NPCSV_H_
#define NPCSV_H_


#include <stdio.h>
#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitCSV (void* dataRef);
void npCloseCSV (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenCSV (const char* fileName, const char* mode, void* dataRef);

FILE* npCSVNew (const char* fileName, const char* mode, void* dataRef);

FILE* npCSVDialog (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npCloseCSV (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadCSV (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteCSV (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveCSV (FILE* file, void* dataRef);

void npImportCSV (FILE* file, int type, void* dataRef);
void npExportCSV (FILE* file, void* dataRef);

// file and directory management
void npGetAttribCSV (int size, void* dataRef);
void npSetAttribCSV (int size, void* dataRef);

void npTestCSV (void* fileName, int wordSize, int size, void* dataRef);


#endif